with Chip.General_Purpose_IOs, Chip.Reset_and_Clock;

package Board is
	use Chip.General_Purpose_IOs, Chip.General_Purpose_IOs.GPIO_Base, Chip.Reset_and_Clock;

	-- LED

	LED_Port : GPIO_Registers renames GPIOG;
	LED_Bit  : constant Port_Bit_Number := 13;
	LED_On   : constant Boolean := True;

	LED_RCC_EN : Boolean renames RCC.AHB1ENR (Index.GPIOG);

	LED_2_Port : GPIO_Registers renames GPIOG;
	LED_2_Bit  : constant Port_Bit_Number := 14;
	LED_2_On   : constant Boolean := True;

	LED_2_RCC_EN : Boolean renames RCC.AHB1ENR (Index.GPIOG);

	-- More internals
	HSE_Frequency : constant := 8_000_000;
	APB2_Frequency : constant := 90_000_000; -- Set by board support

end Board;