package STM32.Address_Map with Pure is

	-- Regions / memories
	Aliased_Memory : constant := 16#0000_0000#;
	Flash_Memory   : constant := 16#0800_0000#;
	CCM_RAM        : constant := 16#1000_0000#;
	Option_Bytes   : constant := 16#1FFE_C000#;
	System_Memory  : constant := 16#1FFF_0000#;
	Option_Bytes_2 : constant := 16#1FFF_C000#;
	SRAM_1         : constant := 16#2000_0000#;
	SRAM_2         : constant := 16#2001_C000#;
	SRAM_3         : constant := 16#2002_0000#;

	-- APB1
	APB1           : constant := 16#4000_0000#;
	TIM2           : constant := 16#4000_0000#;
	TIM3           : constant := 16#4000_0400#;
	TIM4           : constant := 16#4000_0800#;
	TIM5           : constant := 16#4000_0C00#;
	TIM6           : constant := 16#4000_1000#;
	TIM7           : constant := 16#4000_1400#;
	TIM12          : constant := 16#4000_1800#;
	TIM13          : constant := 16#4000_1C00#;
	TIM14          : constant := 16#4000_2000#;
	RTC_and_BKP    : constant := 16#4000_2800#;
	WWDG           : constant := 16#4000_2C00#;
	IWDG           : constant := 16#4000_3000#;
	I2S2ext        : constant := 16#4000_3400#;
	SPI2_I2S2      : constant := 16#4000_3800#;
	SPI3_I2S3      : constant := 16#4000_3C00#;
	I2S3ext        : constant := 16#4000_4000#;
	USART2         : constant := 16#4000_4400#;
	USART3         : constant := 16#4000_4800#;
	UART4          : constant := 16#4000_4C00#;
	UART5          : constant := 16#4000_5000#;
	I2C1           : constant := 16#4000_5400#;
	I2C2           : constant := 16#4000_5800#;
	I2C3           : constant := 16#4000_5C00#;
	FMPI2C1        : constant := 16#4000_6000#;
	CAN1           : constant := 16#4000_6400#;
	CAN2           : constant := 16#4000_6800#;
	CAN3           : constant := 16#4000_6C00#;
	PWR            : constant := 16#4000_7000#;
	DAC            : constant := 16#4000_7400#;
	UART7          : constant := 14#4000_7800#;
	UART8          : constant := 14#4000_7C00#;

	-- APB2
	APB2           : constant := 16#4001_0000#;
	TIM1           : constant := 16#4001_0000#;
	TIM8           : constant := 16#4001_0400#;
	USART1         : constant := 16#4001_1000#;
	USART6         : constant := 16#4001_1400#;
	UART9          : constant := 16#4001_1800#;
	UART10         : constant := 16#4001_1C00#;
	ADC1           : constant := 16#4001_2000#;
	ADC2           : constant := 16#4001_2100#;
	ADC3           : constant := 16#4001_2200#;
	ADC_Common     : constant := 16#4001_2300#;
	SDIO           : constant := 16#4001_2C00#;
	SPI1           : constant := 16#4001_3000#;
	SPI4           : constant := 16#4001_3400#;
	SYSCFG         : constant := 16#4001_3800#;
	EXTI           : constant := 16#4001_3C00#;
	TIM9           : constant := 16#4001_4000#;
	TIM10          : constant := 16#4001_4400#;
	TIM11          : constant := 16#4001_4800#;
	SPI5           : constant := 16#4001_5000#;
	SPI6           : constant := 16#4001_5400#;
	SAI1           : constant := 16#4001_5800#;
	LTDC           : constant := 16#4001_6800#;

	-- AHB1
	AHB1           : constant := 16#4002_0000#;
	GPIOA        : constant := 16#4002_0000#;
	GPIOB        : constant := 16#4002_0400#;
	GPIOC        : constant := 16#4002_0800#;
	GPIOD        : constant := 16#4002_0C00#;
	GPIOE        : constant := 16#4002_1000#;
	GPIOF        : constant := 16#4002_1400#;
	GPIOG        : constant := 16#4002_1800#;
	GPIOH        : constant := 16#4002_1C00#;
	GPIOI        : constant := 16#4002_2000#;
	GPIOJ        : constant := 16#4002_2400#;
	GPIOK        : constant := 16#4002_2800#;
	CRC          : constant := 16#4002_3000#;
	RCC          : constant := 16#4002_3800#;
	Flash_IR     : constant := 16#4002_3C00#;
	BKPSRAM      : constant := 16#4002_4000#;
	DMA1         : constant := 16#4002_6000#;
	DMA2         : constant := 16#4002_6400#;
	Ethernet_MAC : constant := 16#4002_8000#;
	DMA2D        : constant := 16#4002_B000#;
	USB_OTG_HS   : constant := 16#4004_0000#;

	-- AHB2
	AHB2           : constant := 16#5000_0000#;
	USB_OTG_FS     : constant := 16#5000_0000#;
	DCMI           : constant := 16#5005_0000#;
	CRYP           : constant := 16#5006_0000#;
	HASH           : constant := 16#5006_0400#;
	RNG            : constant := 16#5006_0800#;

	-- AHB 3
	AHB3           : constant := 16#6000_0000#;
	FMC_Bank_1     : constant := 16#6000_0000#;
	FSMC_Bank1_1   : constant := 16#6000_0000#;
	FSMC_Bank1_2   : constant := 16#6400_0000#;
	FSMC_Bank1_3   : constant := 16#6800_0000#;
	FSMC_Bank1_4   : constant := 16#6C00_0000#;
	FMC_Bank_2     : constant := 16#7000_0000#;
	FMC_Bank_3     : constant := 16#8000_0000#;
	FMC_Bank_4     : constant := 16#9000_0000#;
	FMC_FSMC       : constant := 16#A000_0000#;
	FMC_Bank_5     : constant := 16#C000_0000#;
	FMC_Bank_6     : constant := 16#D000_0000#;

end STM32.Address_Map;
